/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package pr2cv1;

import java.io.*;

/**
 *
 * @author balikm1
 */
public class BankovniUcet implements Serializable, Comparable<BankovniUcet>
{

    public enum Mena
    {
        CZK,
        EUR
    }

    private long id;
    private Zakaznik majitel;
    private Mena mena;
    private double zustatek;

    public BankovniUcet(Zakaznik majitel, Mena mena)
    {
        this.id = System.currentTimeMillis();
        this.majitel = majitel;
        this.mena = mena;
        this.zustatek = 0;
    }

    public long getID()
    {
        return this.id;
    }

    public void setMajitel(Zakaznik majitel)
    {
        this.majitel = majitel;
    }

    public Zakaznik getMajitel()
    {
        return this.majitel;
    }

    public Mena getMena()
    {
        return this.mena;
    }

    public void vlozCastku(double castka)
    {
        this.zustatek += castka;
    }

    public double getZustatek()
    {
        return this.zustatek;
    }

    @Override
    public String toString()
    {
        return "Majitel účtu: " + majitel + "\nZůstatek: " + zustatek + " " + mena.toString();
    }

    @Override
    public boolean equals(Object o)
    {
        if ( this == o ) return true;
        if (o instanceof BankovniUcet)
        {
            BankovniUcet bu = (BankovniUcet)o;
            return (this.id == bu.id);
        }
        return false;
    }

    @Override
    public int hashCode() {
        int hash = 7;
        hash = 59 * hash + (int) (this.id ^ (this.id >>> 32));
        return hash;
    }

    public void saveToFile(String fileName)
    {
        try {
            // Serializace do souboru
            ObjectOutput out = new ObjectOutputStream(new FileOutputStream(fileName));
            out.writeObject(this);
            out.close();
        } catch (IOException e) {
            System.out.println("Chyba při zápisu souboru : "+e);
        }
    }

    public static BankovniUcet loadFromFile(String fileName)
    {
        BankovniUcet bu = null;
        try {
            File file = new File(fileName);
            ObjectInputStream in = new ObjectInputStream(new FileInputStream(file));
            // Deserializace objektu
            bu = (BankovniUcet)in.readObject();
            in.close();
        } catch (ClassNotFoundException e) {
           System.out.println("Nemohu najít definici třídy: "+e);
        } catch (IOException e) {
           System.out.println("Chyba při čtení souboru : "+e);
        }
        return bu;
    }

    public int compareTo(BankovniUcet bu) {
        final int BEFORE = -1;
        final int EQUAL = 0;
        final int AFTER = 1;

        if ( this == bu ) return EQUAL;

        if ( this.zustatek < bu.zustatek) return BEFORE;
        if ( this.zustatek > bu.zustatek) return AFTER;

        return EQUAL;
    }

}
